'***************************************************************************************
'
'ACHTUNG!
'Sie handeln auf eigene Gefahr!
'Bei diesen Daten handelt es sich um Beispielanwendungen die nicht fr den produktiven
'Einsatz geeignet sind.
'Pollin Electronic gibt keine Garantien irgendeiner Art, weder ausdrcklich
'noch implizit, einschlielich unbegrenzt aller Garantien der Verwendbarkeit
'dieser Daten fr einen bezeichneten oder nicht bezeichneten Zweck.
'Pollin Electronic ist nicht haftbar fr jedwede Folgeschden die aufgrund
'der Benutzung dieser Daten entstehen. Dies gilt auch dann, wenn
'Pollin Electronic von der Mglichkeit eines solchen Schadens unterrichtet worden ist.
'
'Testprogramm fuer ATTiny2313, ATMega8, ATMega16, ATMega32,
'ATMEL Evaluations-Board Best.Nr. 810 038 und
'ATMEL Addon-Board V1.0 Best.Nr. 810 053
'***************************************************************************************

 
 $regfile = "m32def.dat"
'Taktfrequenz 1MHz
 $crystal = 1000000
'Baudrate fr UART
 $baud = 2400

 #if _chip = 0                                              'Tiny 2313
   Lcd_db4 Alias Portb.2
   Lcd_db5 Alias Portb.3
   Lcd_db6 Alias Portb.4
   Lcd_db7 Alias Portb.5
   Lcd_e Alias Portb.6
   Lcd_rs Alias Portb.7
   Led5 Alias Portd.3
   Led6 Alias Portd.4
   Led7 Alias Portd.5
   Led8 Alias Portd.6
   Ir Alias Pind.2
   Irport Alias Portd.2
 #endif

 #if _chip = 17                                             'Mega8
   Lcd_db4 Alias Portb.0
   Lcd_db5 Alias Portb.1
   Lcd_db6 Alias Portb.2
   Lcd_db7 Alias Portb.3
   Lcd_e Alias Portb.4
   Lcd_rs Alias Portb.5
   Led1 Alias Portc.2
   Led2 Alias Portc.3
   Led3 Alias Portc.4
   Led4 Alias Portc.5
   Led5 Alias Portd.3
   Led6 Alias Portd.4
   Led7 Alias Portd.5
   Led8 Alias Portd.6
   Taste1port Alias Portc.1
   Taste1 Alias Pinc.1
   Summer Alias Portd.7
   Ir Alias Pind.2
   Irport Alias Portd.2
   Nf Alias Portc.0
 #endif

 #if _chip = 18                                             'Mega16
   Lcd_db4 Alias Portb.2
   Lcd_db5 Alias Portb.3
   Lcd_db6 Alias Portb.4
   Lcd_db7 Alias Portb.5
   Lcd_e Alias Portb.6
   Lcd_rs Alias Portb.7
   Led1 Alias Porta.2
   Led2 Alias Porta.3
   Led3 Alias Porta.4
   Led4 Alias Porta.5
   Led5 Alias Portd.3
   Led6 Alias Portd.4
   Led7 Alias Portd.5
   Led8 Alias Portd.6
   Taste1port Alias Porta.1
   Taste1 Alias Pina.1
   Summer Alias Portd.7
   Ir Alias Pind.2
   Irport Alias Portd.2
   Nf Alias Porta.0
 #endif

 #if _chip = 23                                             'Mega32
   Lcd_db4 Alias Portb.2
   Lcd_db5 Alias Portb.3
   Lcd_db6 Alias Portb.4
   Lcd_db7 Alias Portb.5
   Lcd_e Alias Portb.6
   Lcd_rs Alias Portb.7
   Led1 Alias Porta.2
   Led2 Alias Porta.3
   Led3 Alias Porta.4
   Led4 Alias Porta.5
   Led5 Alias Portd.3
   Led6 Alias Portd.4
   Led7 Alias Portd.5
   Led8 Alias Portd.6
   Taste1port Alias Porta.1
   Taste1 Alias Pina.1
   Summer Alias Portd.7
   Ir Alias Pind.2
   Irport Alias Portd.2
   Nf Alias Porta.0
 #endif

 Dim Username As String * 20
 Dim W As Byte
 Dim I As Byte
 Dim Adresse As Byte
 Dim Kommando As Byte

'**************************************
'********* LCD-Konfiguration **********
'**************************************
'LCD als 16x2 Zeichen konfigurieren
 Config Lcd = 16 * 2
'LCD-Pins konfigurieren
 Config Lcdpin = Pin , Db4 = Lcd_db4 , Db5 = Lcd_db5 , Db6 = Lcd_db6 , Db7 = Lcd_db7 , E = Lcd_e , Rs = Lcd_rs
'LCD wird im 4-Bit-Modus betrieben
 Config Lcdbus = 4
'**************************************
'********* Port-Konfiguration *********
'**************************************
'LED-Ausgnge
#if _chip <> 0
 Config Led1 = Output
 Config Led2 = Output
 Config Led3 = Output
 Config Led4 = Output
#endif
 Config Led5 = Output
 Config Led6 = Output
 Config Led7 = Output
 Config Led8 = Output
'Tasteneingang
#if _chip <> 0
 Config Taste1port = Input
#endif
'IR-Eingang
 Config Rc5 = Ir
 Irport = 1
'NF-Ausgang
#if _chip <> 0
 Config Nf = Output
#endif
'**************************************
'******** LCD initialisieren **********
'**************************************
 Initlcd
'Display lschen
 Cls
#if _chip <> 0
'**************************************
'*** 3x Test-Tonausgabe auf Summer ****
'**************************************
 'Uart-TextAusgabe
 Print "Summertest"

 For I = 1 To 3
   'Displayposition Zeile 1, Position 1
    Locate 1 , 1
   'Display-Textausgabe
    Lcd "Summertest"
   'Displayposition Zeile 2, Position 1
    Locate 2 , 1
   'Display-Textausgabe
    Lcd "Durchgang "
    Lcd I

   'eigentliche Soundausgabe auf den Summer
    For W = 20 To 250
       Sound Summer , 2 , W
    Next
 Next
 Cls
'**************************************
'** 3x Test-Tonausgabe NF-Verstrker **
'**************************************
 Cls
 'Uart-TextAusgabe
 Print "NF-Verstaerker-Test"

 For I = 1 To 3
   'Displayposition Zeile 1, Position 1
    Locate 1 , 1
   'Display-Textausgabe
    Lcd "NV-Verstaerker"
   'Displayposition Zeile 2, Position 1
    Locate 2 , 1
   'Display-Textausgabe
    Lcd "Testlauf "
    Lcd I

   'eigentliche Soundausgabe
    For W = 20 To 250
       Sound Nf , 2 , W
    Next
 Next
#endif
'**************************************
'************* LED-Test ***************
'**************************************
 Cls
 Print "LED-Test"
 Print "LEDs an"

 Locate 1 , 1
 Lcd "LED-Test"
 Locate 2 , 1
 Lcd "LEDs an"
#if _chip <> 0
 Set Led1
 Set Led2
 Set Led3
 Set Led4
#endif
 Set Led5
 Set Led6
 Set Led7
 Set Led8
 Wait 2
#if _chip <> 0
 Reset Led1
 Reset Led2
 Reset Led3
 Reset Led4
#endif
 Reset Led5
 Reset Led6
 Reset Led7
 Reset Led8
 Locate 2 , 1
 Lcd "LEDs aus"
 Print "LEDs aus"
 Wait 1
#if _chip <> 0
'**************************************
'************* Tasten-Test ************
'**************************************
 Cls
 Print "Tasten-Test"

 Locate 1 , 1
 Lcd "Tasten-Test"

 For I = 1 To 3
   Led8 = 1
   Led7 = 0
   Locate 2 , 1
   Lcd "Taste 1 druecken"
   Print "Taste 1 druecken"
   While Taste1 = 0
   Wend
   Led8 = 0
   Led7 = 1
   Locate 2 , 1
   Lcd "Taste1 gedrueckt"
   Print "Taste1 gedrueckt"
   While Taste1 = 1
   Wend
 Next
 Reset Led1
 Reset Led7
#endif
'**************************************
'************ UART-Test ***************
'**************************************
 Cls
 Locate 1 , 1
 Lcd "UART-Test"
 Locate 2 , 1
 Lcd "Namen eingeben"
'Auf Benutzerdaten ber serielle Schnittstelle warten
'Ende wird erkannt durch CR+LF
 Input "Wie ist Ihr Name?: " , Username
 Print "Hi " ; Username ; " auch die UART-Kommunikation funktioniert"
 Cls
 Locate 1 , 1
 Lcd "Hi "
 Lcd Username
 Wait 2
'**************************************
'************ IR-Test *****************
'**************************************
 Enable Interrupts
 Cls
 Locate 1 , 1
 Lcd "RC5 IR-Test"
 Print "RC5 IR-Test"
 I = 3
 Do
   'Auf RC5-Kommando warten
   Getrc5(adresse , Kommando)
   'test ob Adresse gltig ist
   If Adresse < 255 Then
     'falls ja, dann anzeigen
     Kommando = Kommando And &B01111111                     ' Togglebit lschen
     Cls
     Locate 1 , 1
     Lcd "RC5-Kommando "
     Lcd Kommando
     Print "RC5-Kommando " ; Kommando
     I = I - 1
   End If
   If I = 0 Then Exit Do
   Waitms 200
 Loop
 Disable Interrupts
'**************************************
'***** Displayausgabe Test beendet ****
'**************************************
 Print "Testlauf beendet"
 Cls
 Locate 1 , 1
 Lcd "Testlauf beendet"

'Endlosschleife
 Do
 Loop

'Programmende
End